/*******************************************************************************
 * Copyright (c) 2013 Olivier Langella <Olivier.Langella@moulon.inra.fr>
 * 
 * This file is part of XTandemPipeline.
 * 
 *     XTandemPipeline is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     XTandemPipeline is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with XTandemPipeline.  If not, see <http://www.gnu.org/licenses/>.
 * 
 ******************************************************************************/
package fr.inra.pappso.xtandempipeline.class_msms;

import java.io.File;

public class PeakListFile implements Comparable<PeakListFile> {

	private File peakListFile;

	@Override
	public int hashCode() {
		return peakListFile.hashCode();
	}

	@Override
	public boolean equals(Object toCompareIn) {
		PeakListFile toCompare = (PeakListFile) toCompareIn;
		return (this.peakListFile.equals(toCompare.peakListFile));
	}

	@Override
	public int compareTo(PeakListFile fileIn) {
		return (this.peakListFile.compareTo(fileIn.peakListFile));
	}

	public PeakListFile(String filePath) {
		this.peakListFile = new File(filePath);
	}

	public String getName() {
		return peakListFile.getName();
	}

	public boolean exists() {
		return peakListFile.exists();
	}

	public String getAbsolutePath() {
		return peakListFile.getAbsolutePath();
	}

	public String getBaseName() {
		String basename = this.peakListFile.getName();
		basename = basename.replaceFirst(".mzXML$", "");
		basename = basename.replaceFirst(".mgf$", "");
		basename = basename.replaceFirst(".mzData$", "");
		basename = basename.replaceFirst(".mzML$", "");
		basename = basename.replaceFirst(".pkl$", "");
		basename = basename.replaceFirst(".xml$", "");
		return basename;
	}

}
