package fr.inra.pappso.xtandempipeline.class_msms;

import java.util.HashSet;
import java.util.Iterator;

import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;

public class PhosphoIslandSet implements Iterable<PhosphoIsland> {

	HashSet<PhosphoIsland> phosphoIslandList = new HashSet<PhosphoIsland>(0);

	/**
	 * 
	 */
	// private static final Logger logger =
	// Logger.getLogger(PhosphoIslandSet.class);

	public PhosphoIslandSet(Match match) throws Exception {
		for (Peptide peptide : match.get_valid_peptides()) {
			this.addPeptide(peptide);
		}
	}

	private void addPeptide(Peptide peptide) throws Exception {
		if (peptide.is_phopho_peptide()) {
			PhosphoIsland island = new PhosphoIsland(peptide);

			this.add(island);
		}
	}

	private boolean add(PhosphoIsland islandToAdd) throws Exception {
		HashSet<PhosphoIsland> newIslandList = new HashSet<PhosphoIsland>(0);

		newIslandList.add(islandToAdd);

		for (PhosphoIsland group : phosphoIslandList) {
			if (islandToAdd.fusionWith(group)) {
			} else {
				newIslandList.add(group);
			}
		}

		this.phosphoIslandList.clear();
		this.phosphoIslandList.addAll(newIslandList);
		return true;

	}

	public Iterator<PhosphoIsland> iterator() {
		return this.phosphoIslandList.iterator();
	}
}
