package fr.inra.pappso.xtandempipeline.grouping;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

public class AlgoGroupingBase {
	private static final Logger logger = Logger
			.getLogger(AlgoGroupingBase.class);

	final SubGroupSet subGroupSet = new SubGroupSet();

	final public GroupSet getGroupSet() throws Exception {
		GroupSet resultGroupSet = new GroupSet();
		if (subGroupSet.size() == 0) {
			String message = "There is nothing to group";
			logger.info(message);
			// throw new MSMSException(message);
			return resultGroupSet;
		}
		try {
			logger.info("Perform grouping with algo "
					+ this.getClass().getName());

			logger.info("Number of subgroup before group creation : "
					+ subGroupSet.size());
			resultGroupSet.groupingSubGroupSet(subGroupSet);
			return resultGroupSet;
		} catch (Exception e) {
			String message = "ERROR in " + this.getClass().getName() + " : "
					+ e.getMessage();
			logger.error(message);
			throw new MSMSException(message);
		}
	}
}
