package fr.inra.pappso.xtandempipeline.grouping;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.grouping.interfaces.GrpMsSample;

public class HashPeptide extends HashKey4Groups {
	private static final Logger logger = Logger.getLogger(HashPeptide.class);
	private HashSampleScan hashSampleScan;
	private String sequence;

	protected HashPeptide(HashSampleScan hashSampleScan, String sequence) {
		this.hashSampleScan = hashSampleScan;
		this.sequence = sequence;
	}

	@Override
	public boolean equals(Object toCompare) {
		return (this == toCompare);
	}

	@Override
	public String toString() {
		return hashSampleScan.toString() + " " + sequence;

	}

	public String getSequence() {
		return sequence;
	}

	public int getScan() {
		return hashSampleScan.getScan();
	}

	public GrpMsSample getGrpMsSample() {
		return hashSampleScan.getGrpMsSample();
	}

	public String getHumanId() {
		return hashSampleScan.getScan() + "-" + sequence;
	}

}
