package fr.inra.pappso.xtandempipeline.grouping;

import java.util.HashMap;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

public class HashPeptideSet extends HashKey4GroupsSet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7091759954139159590L;

	/**
	 * 
	 */
	private static final Logger logger = Logger.getLogger(HashPeptideSet.class);

	// Uique String to be sur that wath is use for key!!!
	private HashMap<String, HashPeptide> mapHashPeptide = new HashMap<String, HashPeptide>(
			0);

	public HashPeptideSet() {
		// logger.debug("HashPeptideSet begin");
	}

	@Override
	public void clear() {
		mapHashPeptide = new HashMap<String, HashPeptide>(0);
		super.clear();
	}

	public HashPeptide getInstance(HashSampleScan sampleScan, String sequence)
			throws MSMSException {
		if (sampleScan == null) {
			throw new MSMSException("sampleScan is null");
		}
		String tmpString = sampleScan.getGrpMsSample().getSampleName() + "-"
				+ sampleScan.getScan() + "-" + sequence;
		HashPeptide temp = mapHashPeptide.get(tmpString);
		if(temp == null ){
			// this HashPeptide is new
			temp = new HashPeptide(sampleScan, sequence);
			mapHashPeptide.put(tmpString, temp);
			boolean test = this.add(temp);
			if(!test){
				logger.error("HashPeptide COLLISION, must never appear");
			}
			return (temp);
		}else{
			// find the existing instance of the same peptide scan :
			return(temp);
		}
	}
}
