package fr.inra.pappso.xtandempipeline.output;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;

import javax.xml.stream.XMLOutputFactory;

//import com.sun.xml.internal.txw2.output.IndentingXMLStreamWriter;
import javax.xml.stream.XMLStreamWriter;

import org.apache.log4j.Logger;

import fr.inra.moulon.proticport.model.exceptions.ProticPortException;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;
import fr.inra.pappso.xtandempipeline.thread.XtpProcess;

public class XpipOutput {
	private static final Logger logger = Logger.getLogger(XpipOutput.class);

	XMLStreamWriter writer;
	OutputStream outputStream;
	XpipWriter xpipWriter;

	public XpipOutput() throws ProticPortException {
	}

	public void open(OutputStream outputStream) throws MSMSException {

		try {

			this.outputStream = outputStream;
			XMLOutputFactory factory = XMLOutputFactory.newInstance();
			// OutputStreamWriter noIndentOutput = new OutputStreamWriter(
			// outputStream, "UTF8");
			// XMLStreamWriter writer =
			// factory.createXMLStreamWriter(noIndentOutput);
			OutputStreamWriter output = new OutputStreamWriter(outputStream,
					"UTF8");

			writer = new IndentingXMLStreamWriter(
					factory.createXMLStreamWriter(output));
			writer.writeStartDocument("UTF-8", "1.0");

			xpipWriter = new XpipWriter(writer);

			logger.debug("No errors writing XPIP. All seems OK!");
		} catch (Exception e) {
			try {
				outputStream.write(e.getMessage().toString().getBytes());
			} catch (IOException e1) {
				logger.debug("ERROR : " + e.getMessage(), e);
			}
			// throw new ProticPortException ("ERROR writing mzXml "+
			// e.getMessage());
			logger.debug("ERROR writing XPIP : " + e.getMessage(), e);
		}
	}

	public void close() {
		try {
			xpipWriter.close();
			outputStream.flush();

			logger.debug("No errors writing XPIP. All seems OK!");
		} catch (Exception e) {
			try {
				outputStream.write(e.getMessage().toString().getBytes());
			} catch (IOException e1) {
				logger.debug("ERROR : " + e.getMessage(), e);
			}
			// throw new ProticPortException ("ERROR writing mzXml "+
			// e.getMessage());
			logger.debug("ERROR writing XPIP : " + e.getMessage(), e);
		}
	}

	public void write(ArrayList<Identification> identifications,
			DataType_Base datatype, XtpProcess p) throws Exception {

		xpipWriter.write(identifications, datatype, p);
	}
}
