package fr.inra.pappso.xtandempipeline.thread;

import java.io.File;

import org.apache.log4j.Logger;

import fr.inra.pappso.csv2ods.TsvWriterOneSheet;
import fr.inra.pappso.libodsstream.OdsDocWriterInterface;
import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparPaiOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparSpecificSpectraOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparSpecificUniqueSpectraOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparSpectraOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparUniqueSpectraOutput;

public class printing_combine extends printing_base {
	protected static final Logger logger = Logger
			.getLogger(printing_combine.class);

	public printing_combine(config conf) {
		super(conf);
	}

	@Override
	protected void printComparPai(OdsDocWriterInterface odsDoc)
			throws Exception {
		logger.debug("printComparPai begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar PAI results");
		if (this.isCsv) {
			odsDoc = new TsvWriterOneSheet(new File(this.getfileout()
					.getAbsolutePath() + "_compar_pai.txt"));
		} else {
		}

		OdsComparPaiOutput writer = new OdsComparPaiOutput(odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparPai end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath() + "_compar_pai.txt");
		}
	}

	@Override
	protected void printComparSpectra(OdsDocWriterInterface odsDoc)
			throws Exception {
		logger.debug("printComparSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar spectra list results");
		if (this.isCsv) {
			odsDoc = new TsvWriterOneSheet(new File(this.getfileout()
					.getAbsolutePath() + "_compar_spectra.txt"));
		} else {
		}

		OdsComparSpectraOutput writer = new OdsComparSpectraOutput(odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_spectra.txt");
		}
	}

	@Override
	protected void printComparSpecificSpectra(OdsDocWriterInterface odsDoc)
			throws Exception {
		logger.debug("printComparSpecificSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar specific spectra list results");
		if (this.isCsv) {
			odsDoc = new TsvWriterOneSheet(new File(this.getfileout()
					.getAbsolutePath() + "_compar_specific_spectra.txt"));
		} else {
		}

		OdsComparSpecificSpectraOutput writer = new OdsComparSpecificSpectraOutput(
				odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparSpecificSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_specific_spectra.txt");
		}
	}

	@Override
	protected void printComparSpecificUniqueSpectra(OdsDocWriterInterface odsDoc)
			throws Exception {
		logger.debug("printComparSpecificUniqueSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar specific unique sequences list results");
		if (this.isCsv) {
			odsDoc = new TsvWriterOneSheet(new File(this.getfileout()
					.getAbsolutePath()
					+ "_compar_specific_unique_sequences.txt"));
		} else {
		}

		OdsComparSpecificUniqueSpectraOutput writer = new OdsComparSpecificUniqueSpectraOutput(
				odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparSpecificUniqueSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_specific_unique_sequences.txt");
		}

	}

	@Override
	protected void printComparUniqueSpectra(OdsDocWriterInterface odsDoc)
			throws Exception {
		logger.debug("printComparUniqueSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar unique sequences list results");
		if (this.isCsv) {
			odsDoc = new TsvWriterOneSheet(new File(this.getfileout()
					.getAbsolutePath() + "_compar_unique_sequences.txt"));
		} else {
		}

		OdsComparUniqueSpectraOutput writer = new OdsComparUniqueSpectraOutput(
				odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparUniqueSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_unique_sequences.txt");
		}

	}
}
