package fr.inra.pappso.xtandempipeline.ui.results;

import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.ui.swt.Main_Windows;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;


public class window_base {
	
	protected static final Logger logger = Logger.getLogger(window_base.class);
	
	protected Shell shell;

	protected Main_Windows controlleur;

	protected config conf;

	protected MenuItem menuitem;

	protected CTabFolder folder;

	protected boolean linked_to_main;

	public window_base(Main_Windows global) {
		this.controlleur = global;
		this.conf = XtandemPipelineSession.getInstance().getConfig();
		this.linked_to_main = true;
	}

	public void set_menu_item(MenuItem menu) {
		this.menuitem = menu;
	}

	public void open_windows() {
		shell = new Shell(controlleur.getDisplay());
		shell.setText(menuitem.getText());
		shell.setImages(controlleur.getImages());
		this.menuitem.getMenu().getItem(0).setSelection(true);
		menuitem.getMenu().getItem(1).setEnabled(true);
		menuitem.getMenu().getItem(2).setEnabled(true);
		shell.setData("menuitem", this.menuitem);

		if (linked_to_main) {
			shell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent de) {
					Shell se = (Shell) de.widget;
					if(!shell.equals(se)){
						logger.error("Not the valid shell to dispose");
					}
					logger.debug("close windows : "+shell.getText());
					menuitem.getMenu().getItem(0).setSelection(false);
					menuitem.getMenu().getItem(1).setEnabled(false);
					menuitem.getMenu().getItem(2).setEnabled(false);
					shell.dispose();
					shell = null;
					folder= null;
				}

			});
		}
		else {
			shell.setText(menuitem.getText()+" (Standalone)");
			shell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent de) {
					Shell se = (Shell) de.widget;
					if(!shell.equals(se)){
						logger.error("Not the valid shell to dispose");
					}
					logger.debug("close windows : "+se.getText());
					se.dispose();
					shell = null;
					folder= null;
				}

			});
		}
		this.defined_UI();

		this.initialise();

		shell.open();
	}

	protected void defined_UI() {
		this.shell.setLayout(new FillLayout());
		folder = new CTabFolder(shell, SWT.BORDER);
		folder.setSimple(false);
		this.add_CTabItem();
		if (linked_to_main) {
			CTabItem item2 = new CTabItem(folder, SWT.NONE);
			item2.setText("+");

			folder.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					CTabFolder fold = (CTabFolder) e.widget;
					logger.debug("Tab :" + fold.getSelection().getText());
					if (fold.getSelection().getText().equals("+")) {
						window_base.this.add_CTabItem();
					}

				}
			});
			move_tab_listener listener = new move_tab_listener(this);
			folder.addListener(SWT.DragDetect, listener);
			folder.addListener(SWT.MouseUp, listener);
			folder.addListener(SWT.MouseMove, listener);
		}
	}

	protected void add_CTabItem() {
		int posi = folder.getItemCount() - 1;
		posi = Math.max(0, posi);
		CTabItem item = new CTabItem(folder, SWT.CLOSE, posi);
		item.setText("Item new");
		folder.setSelection(item);
	}

	protected void move_CTabItem(CTabItem item, int index) throws MSMSException {
		CTabItem newItem = new CTabItem(folder, SWT.CLOSE, index);
		newItem.setText(item.getText());
		Control c = item.getControl();
		item.setControl(null);
		newItem.setControl(c);
		item.dispose();
		folder.setSelection(newItem);
	}

	protected void view_CTab_Item_in_independant_windows(CTabItem dragItem,
			Point point) {
		window_base win = new window_base(controlleur);
		win.setLinked_to_main(false);
		win.set_menu_item(menuitem);
		win.open_windows();
		dragItem.setControl(null);
		dragItem.dispose();

	}

	protected void initialise() {

	}

	protected void view_error(Exception e, String text_error) {
		this.controlleur.view_error(e, text_error);
//		StackTraceElement[] f = e.getStackTrace();
//		String error = e.getMessage() + "\nat : " + f[0].toString() + "\n"
//				+ f[1].toString();
//		MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
//		messageBox.setMessage(text_error + "\n" + error);
//		messageBox.open();
//		e.printStackTrace();
	}

	public Shell getShell() {
		return shell;
	}

	public void setShell(Shell shell) {
		this.shell = shell;
	}

	public CTabFolder getFolder() {
		return folder;
	}

	public void setFolder(CTabFolder folder) {
		this.folder = folder;
	}

	public Main_Windows getControlleur() {
		return controlleur;
	}

	public void setControlleur(Main_Windows controlleur) {
		this.controlleur = controlleur;
	}

	public config getConf() {
		return conf;
	}

	public void setConf(config conf) {
		this.conf = conf;
	}

	public boolean isLinked_to_main() {
		return linked_to_main;
	}

	public void setLinked_to_main(boolean linked_to_main) {
		this.linked_to_main = linked_to_main;
	}
};

class move_tab_listener implements Listener {
	private static final Logger logger = Logger.getLogger(move_tab_listener.class);
	private boolean drag = false;
	private CTabItem dragItem;
	private window_base window;

	public move_tab_listener(window_base window) {
		this.window = window;
	}

	public void handleEvent(Event e) {
		Point p = new Point(e.x, e.y);
		if (e.type == SWT.DragDetect) {
			p = window.getFolder().toControl(
					window.getShell().getDisplay().getCursorLocation());
		}
		switch (e.type) {
		case SWT.DragDetect: {
			logger.debug("drag");
			CTabItem item = window.getFolder().getItem(p);
			if (item == null)
				return;
			drag = true;
			dragItem = item;
			Cursor cursor = new Cursor(e.display, SWT.CURSOR_HAND);
			window.getFolder().setCursor(cursor);
			break;
		}
		case SWT.MouseUp: {
			logger.debug("UP");
			if (!drag)
				return;
			window.getFolder().setInsertMark(null, false);
			CTabItem item = window.getFolder().getItem(new Point(p.x, p.y));
			if (item != null) {
				if (!dragItem.equals(item)) {
					logger.debug("Correct");
					// Rectangle rect = item.getBounds();
					// boolean after = p.x > rect.x + rect.width / 2;
					boolean after = window.getFolder().indexOf(item) > window
							.getFolder().indexOf(dragItem);
					int index = window.getFolder().indexOf(item);
					index = after ? index + 1 : index;
					index = Math.max(0, index);
					try {
						window.move_CTabItem(dragItem, index);
					} catch (MSMSException e1) {
						e1.printStackTrace();
					}
				}
			} else {
				logger.debug("No Correct");
				window.view_CTab_Item_in_independant_windows(dragItem,
						new Point(p.x, p.y));
			}
			drag = false;
			dragItem = null;
			Cursor cursor = new Cursor(e.display, SWT.CURSOR_ARROW);
			window.getFolder().setCursor(cursor);
			break;
		}
		case SWT.MouseMove: {
			if (!drag)
				return;
			CTabItem item = window.getFolder().getItem(new Point(p.x, p.y));
			if (item == null) {
				window.getFolder().setInsertMark(null, false);
				return;
			}
			// Rectangle rect = item.getBounds();
			// boolean after = p.x > rect.x + rect.width / 2;
			window.getFolder().setInsertMark(item, true);
			break;
		}
		}
	}
};
