package fr.inra.pappso.xtandempipeline.ui.swt;

import java.io.File;
import java.util.Arrays;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile.IdentificationDataSource;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;

public class Filter_Windows {
	protected config conf;
	private Vector<IdentificationDataSource> addDataFile;
	private String current_directory;
	private Shell shell;
	private Text pep_evalue;
	private Text prot_evalue;
	private Text pep_number;
	private Button filter_to_all;
	private Button theoriticalButton;
	private Boolean Cancelled;
	private DataType_Base type;
	private Text minimumPeptideProphetProbability;
	private Text minimumPeptideInterProphetProbability;

	public Filter_Windows(Main_Windows controlleur) {
		Cancelled = true;
		this.conf = XtandemPipelineSession.getInstance().getConfig();
		this.type = XtandemPipelineSession.getInstance().getDataTypeBase();
		this.addDataFile = new Vector<IdentificationDataSource>();
		current_directory = conf.getXmlresult().getAbsolutePath();
		shell = new Shell(controlleur.getDisplay(), SWT.DIALOG_TRIM
				| SWT.APPLICATION_MODAL);
		shell.setImages(controlleur.getImages());
		// initialise la fenetre
		init();
		// ajoute les données
		add_data();

		// regle et affiche la fenetre
		shell.pack();
		// shell.setSize(500, 600);
		shell.open();
		while (!shell.isDisposed()) {
			if (!controlleur.getDisplay().readAndDispatch()) {
				controlleur.getDisplay().sleep();
			}
		}
	}

	private void init() {
		shell.setText("Filter window");
		GridLayout layout = new GridLayout(1, false);
		layout.marginLeft = layout.marginTop = layout.marginRight = layout.marginBottom = 10;
		layout.verticalSpacing = 10;
		shell.setLayout(layout);
		// AJout des filtres

		Group add_xtandem = new Group(shell, SWT.SHADOW_IN);
		add_xtandem.setText("Choose X!Tandem/Mascot/pepXML result files");
		add_xtandem.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		add_xtandem.setLayout(new GridLayout(2, false));

		Text add_result = new Text(add_xtandem, SWT.SINGLE | SWT.READ_ONLY);
		add_result.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		add_result.setText("No file selected");
		Button add = new Button(add_xtandem, SWT.PUSH);
		add.setText("Add files");
		add.setData("text", add_result);
		add.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Filter_Windows.this.add_clic((Button) e.widget);
			}
		});

		Group filter = new Group(shell, SWT.SHADOW_IN);
		filter.setText("Peptide and protein filters");
		filter.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		filter.setLayout(new GridLayout(2, false));

		pep_evalue = new Text(filter, SWT.SINGLE);
		pep_evalue.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Label l = new Label(filter, SWT.NONE);
		l.setText("Maximum peptide Evalue");

		this.minimumPeptideProphetProbability = new Text(filter, SWT.SINGLE);
		minimumPeptideProphetProbability.setLayoutData(new GridData(
				GridData.FILL_HORIZONTAL));
		l = new Label(filter, SWT.NONE);
		l.setText("Minimum peptide prophet probability");

		this.minimumPeptideInterProphetProbability = new Text(filter,
				SWT.SINGLE);
		minimumPeptideInterProphetProbability.setLayoutData(new GridData(
				GridData.FILL_HORIZONTAL));
		l = new Label(filter, SWT.NONE);
		l.setText("Minimum peptide inter prophet probability");

		pep_number = new Text(filter, SWT.SINGLE);
		pep_number.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		l = new Label(filter, SWT.NONE);
		l.setText("Minimal number of unique peptides to conserve a protein");

		prot_evalue = new Text(filter, SWT.SINGLE);
		prot_evalue.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		l = new Label(filter, SWT.NONE);
		l.setText("Maximum protein log(E value) to conserve a protein");

		Label separator = new Label(filter, SWT.SEPARATOR | SWT.HORIZONTAL);
		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 2;
		separator.setLayoutData(data);

		filter_to_all = new Button(filter, SWT.CHECK);
		filter_to_all.setText("     ");
		filter_to_all.setEnabled(!type.getIs_invididual());
		l = new Label(filter, SWT.NONE);
		l.setText("Apply protein filter to all samples together");

		Group mascotEvalue = new Group(shell, SWT.SHADOW_IN);
		mascotEvalue.setText("Mascot Evalue calculation");
		mascotEvalue.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		mascotEvalue.setLayout(new GridLayout(1, false));

		theoriticalButton = new Button(mascotEvalue, SWT.RADIO);
		theoriticalButton
				.setText("Theoretical (The ion score threshold is the same for all spectra)");
		theoriticalButton.setSelection(conf.get_mascot_evalue_theoritical());
		Button experimentalButton = new Button(mascotEvalue, SWT.RADIO);
		experimentalButton
				.setText("Experimental (The ion score threshold depends on the spectrum)");
		experimentalButton.setSelection(!conf.get_mascot_evalue_theoritical());
		// experimentalButton.setEnabled(false);

		Group database = new Group(shell, SWT.SHADOW_IN);
		database.setText("Remove contaminants");
		// data = new GridData(GridData.FILL_HORIZONTAL);
		// data.horizontalSpan=2;
		// database.setLayoutData(data);
		database.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		database.setLayout(new GridLayout(2, false));

		Text data_conta = new Text(database, SWT.SINGLE | SWT.READ_ONLY);
		data_conta.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		data_conta.setText(conf.get_database_filter().getName());
		Button select = new Button(database, SWT.PUSH);
		select.setText("Select");
		select.setData("text", data_conta);
		select.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Filter_Windows.this.select_clic((Button) e.widget);
			}
		});

		separator = new Label(shell, SWT.SEPARATOR | SWT.HORIZONTAL);
		// data = (new GridData(GridData.FILL_HORIZONTAL));
		// data.horizontalSpan=2;
		separator.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		// l = new Label(shell,SWT.NONE);
		// l.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Button next = new Button(shell, SWT.PUSH);
		next.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		next.setText("Next");
		next.setEnabled(false);
		next.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Filter_Windows.this.next_clic();
			}
		});
		add.setData("next", next);

	}

	private void add_data() {
		prot_evalue.setText(("" + conf.get_protein_evalue()));
		pep_evalue.setText(("" + conf.get_peptide_evalue()));
		pep_number.setText(("" + conf.get_peptide_number()));
		this.minimumPeptideProphetProbability.setText(""
				+ conf.getMinimumPeptideProphetProbability());
		this.minimumPeptideInterProphetProbability.setText(""
				+ conf.getMinimumPeptideInterProphetProbability());
		filter_to_all.setSelection(conf.get_protein_filter_to_complete());
	}

	private void modified_conf() throws MSMSException {
		float fl1;
		float fl2;
		int it;
		try {
			fl1 = Float.valueOf(prot_evalue.getText()).floatValue();
		} catch (Exception e) {
			throw new MSMSException("Log(E value) protein must be like '-8'");
		}
		try {
			fl2 = Float.valueOf(pep_evalue.getText()).floatValue();
		} catch (Exception e) {
			throw new MSMSException("Peptide E value must be like '0.05'");
		}
		try {
			it = Integer.parseInt(pep_number.getText());
		} catch (Exception e) {
			throw new MSMSException("Peptide number must be a number '2'");
		}

		conf.setMinimumPeptideProphetProbability(this.minimumPeptideProphetProbability
				.getText());
		conf.setMinimumPeptideInterProphetProbability(this.minimumPeptideInterProphetProbability
				.getText());
		conf.set_protein_evalue(fl1);
		conf.set_peptide_evalue(fl2);
		conf.set_peptide_number(it);
		if (filter_to_all.getSelection())
			conf.set_protein_filter_to_complete(true);
		else
			conf.set_protein_filter_to_complete(false);

		conf.set_mascot_evalue_theoritical(theoriticalButton.getSelection());
	}

	private void next_clic() {
		try {
			this.modified_conf();
			conf.savePropertiestoXml();
			type.getPro().setDataSource(addDataFile);
			Cancelled = false;
			shell.dispose();
		} catch (MSMSException e) {
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ e.getMessage());
			messageBox.open();
		} catch (Exception e) {
			StackTraceElement[] f = e.getStackTrace();
			String error = e.getMessage() + "\nat : " + f[0].toString();
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ error);
			messageBox.open();
			e.printStackTrace();
		}
	}

	private void select_clic(Button but) {
		Text database_filter = (Text) but.getData("text");
		try {
			File files = this.get_file_fasta();
			conf.set_database_filter(files);

		} catch (StopException S) {

		} catch (Exception e) {
			StackTraceElement[] f = e.getStackTrace();
			String error = e.getMessage() + "\nat : " + f[0].toString();
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox.setMessage("Problems during database selection :\n"
					+ error);
			messageBox.open();
			e.printStackTrace();
		} finally {
			database_filter.setText(conf.get_database_filter().getName());
			database_filter.update();
		}
	}

	private void add_clic(Button but) {
		try {
			IdentificationDataSource[] files = this.getDataSource();
			for (int m = 0; m < files.length; m++) {
				if (!addDataFile.contains(files[m]))
					addDataFile.add(files[m]);
			}
			// for (int i = 0; i < files.length; i++)
			// add_xml.add(files[i]);
			Text t = (Text) but.getData("text");
			t.setText(addDataFile.size() + " files selected");
			t.update();

			if (addDataFile.size() > 0)
				((Button) but.getData("next")).setEnabled(true);

		} catch (StopException S) {

		} catch (Exception e) {
			StackTraceElement[] f = e.getStackTrace();
			String error = e.getMessage() + "\nat : " + f[0].toString();
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox.setMessage("Problems during xml files selection :\n"
					+ error);
			messageBox.open();
			e.printStackTrace();
		} finally {
			// database_filter.setText(conf.get_database_filter().getName());
		}

	}

	private File get_file_fasta() throws StopException {
		FileDialog dlg = new FileDialog(shell, SWT.OPEN | SWT.SINGLE);
		dlg.setFilterPath(conf.getProtein_database().getPath());
		dlg.setText("Select the contaminants database");
		dlg.setFilterExtensions(new String[] { "*.fasta", "*.*" });
		dlg.setFilterNames(new String[] { "Fasta file", "All files" });
		String fileName = dlg.open();
		if (fileName == null)
			throw new StopException("No fasta selected");

		return (new File(fileName));
	}

	private IdentificationDataSource[] getDataSource() throws Exception {
		FileDialog dlg = new FileDialog(shell, SWT.OPEN | SWT.MULTI);
		dlg.setFilterExtensions(new String[] { "*.xml", "*.dat", "*.*" });
		dlg.setFilterNames(new String[] { "X!Tandem result files",
				"Mascot result files", "All files" });
		dlg.setFilterPath(current_directory);
		dlg.setText("Add new xml result files to analyze");
		String fileName = dlg.open();
		if (fileName == null) {
			throw new StopException("No XML file selected");
		}
		String[] f = dlg.getFileNames();
		IdentificationDataSource[] files = new IdentificationDataSource[f.length];
		for (int i = 0; i < f.length; i++) {
			files[i] = (XtandemPipelineSession.getInstance()
					.getIdentificationDataSourceInstance(dlg.getFilterPath()
							+ System.getProperty("file.separator") + f[i]));
		}
		Arrays.sort(files);
		current_directory = dlg.getFilterPath();
		return (files);
	}

	public Vector<IdentificationDataSource> get_Add_xml() {
		return addDataFile;
	}

	public boolean isCancelled() {
		return Cancelled;
	}

}
