package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;
import java.util.Collections;

import fr.inra.pappso.xtandempipeline.Utils;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;

public class calculation_peptide_mh_deviation extends calculation_base_peptide {

	private double sum;

	private ArrayList<Double> list_value_diff;

	private boolean is_ppm;

	public calculation_peptide_mh_deviation(boolean is_ppm) {
		super();
		this.is_ppm = is_ppm;
		list_value_diff = new ArrayList<Double>();
		sum = 0;
		logger.info("Calculation of peptide mass deviation");
	}

	@Override
	protected void processing_peptide(Peptide pep) {
		if (pep.isValid()) {
			double diff = pep.get_mhplus_theo() - pep.get_mhplus_obser();
			if (is_ppm) {
				while (diff < -0.5) {
					diff = diff + (double) Utils.mDeltaC12C13;
				}
				diff = (diff / pep.get_mhplus_theo()) * Utils.onemillion;
			}
			sum += diff;
			list_value_diff.add(diff);
		}
	}

	public double get_mean_deviation() {
		double mean = (double) (sum / list_value_diff.size());
		return (mean);
	}

	public double get_mediane_deviation() {
		Collections.sort(list_value_diff);
		int med = (int) list_value_diff.size() / 2;
		return list_value_diff.get(med);
	}

	public double get_standart_deviation() {
		double var = 0;
		double mean = this.get_mean_deviation();
		for (double val : list_value_diff) {
			var = var + ((val - mean) * (val - mean));
		}
		var = var / list_value_diff.size();
		return (double) Math.sqrt(var);
	}
}
