package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MatchList;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.PeptideProphet;

public class filter_peptide_evalue extends filter_base {

	private float peptide_evalue;
	private Float peptideProphetProbabilityThreshold = null;
	private Float peptideInterProphetProbabilityThreshold = null;

	public filter_peptide_evalue(float evalue,
			Float peptideProphetProbabilityThreshold,
			Float peptideInterProphetProbabilityThreshold) {
		super();
		this.peptide_evalue = evalue;
		this.peptideProphetProbabilityThreshold = peptideProphetProbabilityThreshold;
		this.peptideInterProphetProbabilityThreshold = peptideInterProphetProbabilityThreshold;
		logger.info("Filter peptide on Evalue : " + evalue);
	}

	public int execute(MatchList m) throws MSMSException {
		// processing de la match_list
		for (Match ms : m.getMatchListes()) {
			ArrayList<Peptide> peps = ms.get_all_peptides();
			for (Peptide pep : peps) {
				if (pep.get_evalue() >= this.peptide_evalue) {
					pep.setIsValid(false);
				}
				if (pep.getClass().equals(PeptideProphet.class)) {
					PeptideProphet pepProphet = (PeptideProphet) pep;
					if (peptideProphetProbabilityThreshold != null) {
						if ((pepProphet.getProphetProbability() != null)
								&& (pepProphet.getProphetProbability() < this.peptideProphetProbabilityThreshold)) {
							pep.setIsValid(false);
						}
					}
					if (peptideInterProphetProbabilityThreshold != null) {
						if ((pepProphet.getInterProphetProbability() != null)
								&& (pepProphet.getInterProphetProbability() < this.peptideInterProphetProbabilityThreshold)) {
							pep.setIsValid(false);
						}
					}
				}
			}
			if (ms.getValidSpectraNumber() > 0) {
				numberOfValidMatch++;
			} else {
				ms.setIsvalidate(false);
			}
		}
		return (this.numberOfValidMatch);
	}
}
