package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MatchList;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScan;

public class filter_peptide_redondancy extends filter_base {

	public filter_peptide_redondancy() {
		super();
		logger.info("Filter peptide redundancy +-1 log");
	}

	public int execute(MatchList m) throws MSMSException {
		// processing de la match_list
		for (Match ms : m.getMatchListes()) {
			// on parcourt la liste de hash et on en garde que le meilleur
			// peptide
			for (HashSampleScan hash : ms.getHashSampleScanToPeptide().keySet()) {
				ArrayList<Peptide> peps = ms
						.getAllValidPeptideToHashSampleScan(hash);
				if (peps.size() > 1) {
					for (int i = 1; i < peps.size(); i++) {
						if (Math.log10(peps.get(0).get_evalue())
								- Math.log10(peps.get(i).get_evalue()) < -1) {
							peps.get(i).setIsValid(false);
							logger.debug("Filtering " + hash.toString());
							logger.debug(peps.get(i).get_LI_sequence_modifs()
									+ " is inferior to "
									+ peps.get(0).get_LI_sequence_modifs());
						}

					}
				}

			}
			numberOfValidMatch++;
		}
		return (this.numberOfValidMatch);
	}

}
