package fr.inra.pappso.xtandempipeline.ui.results;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Vector;

import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.TranscoderOutput;
import org.apache.batik.transcoder.image.PNGTranscoder;
import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;

import fr.inra.moulon.svgutils.svgspectrum.SvgAaMod;
import fr.inra.moulon.svgutils.svgspectrum.SvgAaModPhospho;
import fr.inra.moulon.svgutils.svgspectrum.SvgPeptideSequence;
import fr.inra.moulon.svgutils.svgspectrum.SvgSpectrumDocument;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.Modifs;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;

public class Peptide_Details_item extends CTabItem {

	private Text seq;

	private Text mods;
	// private Browser spectre;
	private Label spectre;

	private Text threshold;

	private Text precision;

	private Peptide pep;

	private Image img;

	protected int zoom_x1;

	protected int zoom_x2;

	private window_base window;

	private Vector<Button> buttons;

	private static final Logger logger = Logger
			.getLogger(Peptide_Details_item.class);

	public Peptide_Details_item(window_base parent, int posi) {
		super(parent.getFolder(), SWT.CLOSE, posi);
		this.window = parent;
		buttons = new Vector<Button>();
		this.pep = null;
		// on ajoute le contenu
		this.setControl(this.create_composite());
		for (Button but : buttons)
			but.setEnabled(false);
	}

	protected Composite create_composite() {
		Composite compo_principal = new Composite(window.getFolder(), SWT.NONE);
		GridLayout lay = new GridLayout(3, false);
		lay.verticalSpacing = 5;
		lay.horizontalSpacing = 5;
		compo_principal.setLayout(lay);

		Label l = new Label(compo_principal, SWT.NONE);
		l.setText("Sequence");
		l.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		l = new Label(compo_principal, SWT.NONE);
		l.setText("Modifications");
		l.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		Group menu = new Group(compo_principal, SWT.SHADOW_IN);
		menu.setText("Options");
		menu.setLayoutData(new GridData(SWT.TOP, SWT.FILL, false, true, 1, 3));
		menu.setLayout(new GridLayout(1, false));

		seq = new Text(compo_principal, SWT.SINGLE);
		seq.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		mods = new Text(compo_principal, SWT.SINGLE);
		mods.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		spectre = new Label(compo_principal, SWT.NONE);
		spectre.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));

		spectre.addMouseListener(new MouseListener() {
			public void mouseDoubleClick(MouseEvent arg0) {
				logger.debug("mouseDoubleClick " + arg0.x + "_" + arg0.y);
			}

			public void mouseDown(MouseEvent arg0) {
				zoom_x1 = arg0.x;
				logger.debug("mouseDown " + arg0.x + "_" + arg0.y);
				Cursor cursor = new Cursor(
						window.getControlleur().getDisplay(), SWT.CURSOR_CROSS);
				spectre.setCursor(cursor);
			}

			public void mouseUp(MouseEvent arg0) {
				zoom_x2 = arg0.x;
				logger.debug("mouseUp " + arg0.x + "_" + arg0.y);
				Cursor cursor = new Cursor(
						window.getControlleur().getDisplay(), SWT.CURSOR_ARROW);
				spectre.setCursor(cursor);
				Peptide_Details_item.this.draw_spectra_to(pep, true);
			}
		});

		// ajout dans le menu
		l = new Label(menu, SWT.NONE);
		l.setText("Precision");
		precision = new Text(menu, SWT.SINGLE);
		precision
				.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		precision.setText("0.5");

		l = new Label(menu, SWT.NONE);
		l.setText("Threshold");
		threshold = new Text(menu, SWT.SINGLE);
		threshold
				.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		threshold.setText("0");

		Button redraw = new Button(menu, SWT.PUSH | SWT.CENTER);
		redraw.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		redraw.setText("Redraw");
		redraw.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				zoom_x1 = 0;
				zoom_x2 = 0;
				if (Peptide_Details_item.this.pep != null)
					Peptide_Details_item.this.draw_spectra_to(pep, true);
			}
		});
		this.buttons.add(redraw);

		l = new Label(menu, SWT.SEPARATOR | SWT.HORIZONTAL);
		l.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));

		l = new Label(menu, SWT.NONE);
		l.setText("Width");
		Text width = new Text(menu, SWT.SINGLE);
		width.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		width.setText("600");

		l = new Label(menu, SWT.NONE);
		l.setText("Height");
		Text height = new Text(menu, SWT.SINGLE);
		height.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		height.setText("400");

		Button save = new Button(menu, SWT.PUSH | SWT.CENTER);
		save.setText("Save");
		save.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		save.setData("width", width);
		save.setData("height", height);
		save.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (Peptide_Details_item.this.pep != null)
					Peptide_Details_item.this.save_spectra_to(pep, e.widget);
			}
		});
		this.buttons.add(save);

		return (compo_principal);
	}

	public void save_spectra_to(Peptide pep2, Widget widget) {
		try {
			// on verifie les valeurs indiqué dans les champs text
			Text width = (Text) widget.getData("width");
			Text height = (Text) widget.getData("height");
			float w;
			float h;
			try {
				w = Float.valueOf(width.getText()).floatValue();
			} catch (Exception e) {
				width.setText("600");
				w = 600;
			}
			try {
				h = Float.valueOf(height.getText()).floatValue();
			} catch (Exception e) {
				height.setText("400");
				h = 400;
			}
			SvgSpectrumDocument svgspectrum = this.get_spectra_document(pep2,
					w, h);

			// on demande à l'utilisateur ou il veux enregistrer
			FileDialog dlg = new FileDialog(window.getShell(), SWT.SAVE
					| SWT.SINGLE);
			dlg.setFilterPath(window.getConf().getXmlresult().getPath());
			dlg.setFileName(pep2.get_sample()
					.replaceFirst(".xml$", "")
					+ "_" + pep2.get_scan());
			dlg.setFilterExtensions(new String[] { "*.svg", "*.png" });
			dlg.setFilterNames(new String[] { "SVG Images", "PNG Images" });
			String fileout = dlg.open();
			if (fileout == null)
				throw new StopException("");

			if (dlg.getFilterIndex() == 0) {
				svgspectrum.toFile(new File(fileout.replaceFirst("\\..*$", "")
						+ ".svg"));
			} else {
				save_spectra_png(svgspectrum,
						fileout.replaceFirst("\\..*$", "") + ".png");
			}

		} catch (StopException e) {
			logger.debug("cancel");
		} catch (Exception e) {
			window.view_error(e, "Problems with drawing spectra");
		}
	}

	public void draw_spectra_to(Peptide peptide, boolean redraw) {
		try {
			for (Button but : buttons)
				but.setEnabled(true);

			if (!redraw) {
				this.pep = peptide;
				mods.setText(peptide.get_Modifs_formater());
				seq.setText(peptide.getSequence());
				this.setText("Scan : " + peptide.get_scan() + " mz : "
						+ peptide.get_mz_theo() + " z : "
						+ peptide.getCharge());
				spectre.setText("Loading");
			}

			// on vérifie qu'il y a toujours le fichier
			if (!peptide.getIdentificationDataSource().exists())
				throw new MSMSException("The file : \n"
						+ peptide.getIdentificationDataSource().getName()
						+ "\n is not present in your system.");

			// on charge le spectre
			if (peptide.getIntensity_values() == null)
				peptide.getIdentificationDataSource().loadMSMSSpectra(pep);
			else
				logger.debug("load previous");

			//
			SvgSpectrumDocument svgspectrum = this.get_spectra_document(pep,
					spectre.getSize().x, spectre.getSize().y);
			// Si zoom, on calcul
			if (zoom_x2 - zoom_x1 > 0) {
				float min = 100000;
				float max = 0;
				for (Double db : peptide.getMz_values()) {
					if (db < min)
						min = db.floatValue();
					if (db > max)
						max = db.floatValue();
				}
				float pas = (max - min) / (spectre.getSize().x - 90);
				float first = zoom_x1 - 60;
				if (first <= 0)
					first = min;
				else
					first = min + first * pas;

				float last = zoom_x2 - 60;
				if (last >= spectre.getSize().x)
					last = max;
				else
					last = min + last * pas;
				logger.debug(first + " - " + last);
				svgspectrum.setSpectrumRangeMz(first, last);
			}

			if (this.img != null)
				img.dispose();
			// this.img = new Image(shell.getDisplay(), "xtandem_spectra.png");
			this.img = this.get_spectra_png(svgspectrum);
			spectre.setImage(img);

		} catch (StopException e) {
			logger.debug("shell not open");
		} catch (MSMSException e) {
			spectre.setText(e.getMessage());
		} catch (Exception e) {
			window.view_error(e, "Problems with drawing spectra");
		}
	}

	public SvgSpectrumDocument get_spectra_document(Peptide pep, float width,
			float heigth) throws Exception {

		// on creer le spectre svg
		SvgSpectrumDocument svgspectre = new SvgSpectrumDocument(width, heigth);

		// on verifie les valeurs indiqué dans les champs text
		try {
			svgspectre.setFitPrecision(Float.valueOf(precision.getText())
					.floatValue());
		} catch (Exception e) {
			precision.setText("0.5");
			svgspectre.setFitPrecision((float) 0.5);
		}
		try {
			svgspectre.setPrintThreshold(Float.valueOf(threshold.getText())
					.floatValue());
		} catch (Exception e) {
			threshold.setText("0");
			svgspectre.setPrintThreshold((float) 0);
		}

		svgspectre.setTitle(null);
		// test.setTitle("Scan : " + pep.get_scan() + " mz : "
		// + pep.get_mhplus_theo() + " z : " + pep.get_charge());
		svgspectre.setMzIntensity(pep.getMz_values(),
				pep.getIntensity_values());

		// gerer plus tard la possibilité d'editer la ligne mods/seq?
		SvgPeptideSequence mon_peptide = new SvgPeptideSequence(
				pep.getSequence());
		for (Modifs mod : pep.get_Modifs()) {
			if (mod.is_phopho_modifs() && mod.get_modvalue() > 0) {
				SvgAaMod themod = new SvgAaModPhospho(); // phosphorylated
															// residue
				mon_peptide.getAA(mod.get_posi()).addModification(themod);
			} else {
				mon_peptide.getAA(mod.get_posi()).addModification(
						mod.get_modvalue());
			}

		}
		svgspectre.setSequence(mon_peptide);

		return (svgspectre);
	}

	public void save_spectra_png(SvgSpectrumDocument spec, String file)
			throws Exception {
		PNGTranscoder transcode = new PNGTranscoder();
		TranscoderInput svgInput = new TranscoderInput(
				spec.getRenderedDocument());
		FileOutputStream outStream = new FileOutputStream(file);
		TranscoderOutput imageOutput = new TranscoderOutput(outStream);
		// System.out.println("save");
		transcode.transcode(svgInput, imageOutput);
		outStream.flush();
		outStream.close();
	}

	public Image get_spectra_png(SvgSpectrumDocument spec) throws Exception {
		PNGTranscoder transcode = new PNGTranscoder();
		TranscoderInput svgInput = new TranscoderInput(
				spec.getRenderedDocument());
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		TranscoderOutput imageOutput = new TranscoderOutput(out);
		// System.out.println("save");
		transcode.transcode(svgInput, imageOutput);
		out.flush();
		out.close();
		ByteArrayInputStream in = new ByteArrayInputStream(out.toByteArray());
		Image img = new Image(this.getDisplay(), in);
		in.close();
		return img;
	}

	public Peptide getPep() {
		return pep;
	}

	public void setPep(Peptide pep) {
		this.pep = pep;
	}

}
