package fr.inra.pappso.xtandempipeline.ui.results;

import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;
import fr.inra.pappso.xtandempipeline.ui.swt.Main_Windows;

import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.graphics.Point;

public class Peptide_List extends window_base {

	public Peptide_List(Main_Windows global) {
		super(global);
	}

	protected void initialise() {
		this.shell.setSize(600, 400);
	}

	protected void add_CTabItem() {
		int posi = folder.getItemCount() - 1;
		posi = Math.max(0, posi);
		Peptide_List_item item = new Peptide_List_item(this, posi);
		item.setText("New Tab");
		folder.setSelection(item);
	}

	protected void move_CTabItem(CTabItem item, int index) {
		Peptide_List_item newItem = new Peptide_List_item(this, index);
		Peptide_List_item dragitem = (Peptide_List_item) item;
		newItem.setText(dragitem.getText());
		//Control c = item.getControl();
		dragitem.setControl(null);
		//newItem.setControl(c);
		dragitem.dispose();
		folder.setSelection(newItem);
		if (dragitem.getIdent() != null)
			newItem.load_data(dragitem.getIdent(), dragitem.getProtein(),
					dragitem.getData_type());
	}

	protected void view_CTab_Item_in_independant_windows(CTabItem dragItem,
			Point point) {
		Peptide_List_item dragitem = (Peptide_List_item) dragItem;
		Peptide_List win = new Peptide_List(controlleur);
		win.setLinked_to_main(false);
		win.set_menu_item(menuitem);
		win.open_windows();
		win.getShell().setSize(this.getShell().getSize());
		win.getShell().setLocation(point);
		if (dragitem.getIdent() != null)
			win.load_data(dragitem.getIdent(), dragitem.getProtein(),
					dragitem.getData_type());
		dragItem.setControl(null);
		dragItem.dispose();
	}

	public void load_data(Identification ident, HashSampleScanSetProt hashProt,
			DataType_Base data_type) {
		try {
			if ((this.shell == null) || (this.shell.isDisposed())) {
				this.open_windows();
				// throw new StopException("");
			}
			if (folder.getSelection() == null)
				throw new StopException("");
			Peptide_List_item item = (Peptide_List_item) folder.getSelection();
			item.load_data(ident, hashProt, data_type);

		} catch (StopException e) {
			logger.debug("shell not open");
		} catch (Exception e) {
			this.view_error(e, "Problems with drawing peptide list");
		}
	}
}
