package fr.inra.pappso.xtandempipeline.ui.results;

import java.util.HashMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;


public class Protein_Details_item extends CTabItem {
	
	private window_base window;

	private StyledText coverage;

	private HashSampleScanSetProt m;

	public Protein_Details_item(window_base parent, int posi) {
		super(parent.getFolder(), SWT.CLOSE, posi);
		this.window = parent;
		//on ajoute le contenu
		this.setControl(this.create_composite());
	}

	private Composite create_composite() {
		Composite compo = new Composite(window.getFolder(),SWT.NONE);
		compo.setLayout(new FillLayout());
		coverage = new StyledText(compo,SWT.WRAP|SWT.V_SCROLL|SWT.MULTI|SWT.BORDER);
		coverage.setFont(new Font(compo.getDisplay(), "Courier New", 10, SWT.NORMAL));
		return compo;
	}
	
	public void view_protein_details(HashSampleScanSetProt m) throws MSMSException{
		this.setMatch(m);
		StringBuilder text = new StringBuilder();
		Match match = (Match) m.getGrpProtMatch();
		text.append(">"+match.get_protein_match().get_description()+"\n");
		int start = text.length();
		text.append(match.get_protein_match().get_sequence());
		text.append("\n\n");
		text.append("Coverage: "+match.get_coverage()+"%\n");
		text.append("MW: "+match.get_protein_match().get_mw()+" Da\n");
		text.append("Evalue: "+match.get_protein_match().get_evalue()+"\n");
		coverage.setText(text.toString());		    
		//on ajoute la couverture
		HashMap<Integer, Boolean> seq = match.get_coverage_hashtable();
		for(Integer ST : seq.keySet()){
			if (seq.get(ST).equals(true))
				coverage.setStyleRange(getHighlightStyle(start+ST-1, 1));
		}
		this.setText(match.get_protein_match().get_protein_accession());
	}
	
	private StyleRange getHighlightStyle(int startOffset, int length) {
		StyleRange styleRange = new StyleRange();
		styleRange.start = startOffset;
		styleRange.length = length;
		styleRange.background = window.getShell().getDisplay().getSystemColor(
				SWT.COLOR_YELLOW);
		return styleRange;
	}

	public void setMatch(HashSampleScanSetProt m) {
		this.m = m;
	}

	public HashSampleScanSetProt getMatch() {
		return m;
	}
}
